-- MySQL Administrator dump 1.4
--
-- ------------------------------------------------------
-- Server version	5.1.50-community


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;


--
-- Create schema examen_2015
--

CREATE DATABASE IF NOT EXISTS examen_2015;
USE examen_2015;

--
-- Definition of table `amigo`
--

DROP TABLE IF EXISTS `amigo`;
CREATE TABLE `amigo` (
  `cod_amigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `amigo` varchar(45) NOT NULL,
  PRIMARY KEY (`cod_amigo`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `amigo`
--

/*!40000 ALTER TABLE `amigo` DISABLE KEYS */;
INSERT INTO `amigo` (`cod_amigo`,`amigo`) VALUES 
 (1,'Antonia'),
 (2,'Felipa'),
 (3,'Juan'),
 (4,'Luis'),
 (5,'Maria'),
 (6,'Pedro');
/*!40000 ALTER TABLE `amigo` ENABLE KEYS */;


--
-- Definition of table `come`
--

DROP TABLE IF EXISTS `come`;
CREATE TABLE `come` (
  `cod_amigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `cod_plato` int(10) unsigned NOT NULL,
  `orden` int(10) unsigned NOT NULL,
  PRIMARY KEY (`cod_amigo`,`cod_plato`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `come`
--

/*!40000 ALTER TABLE `come` DISABLE KEYS */;
INSERT INTO `come` (`cod_amigo`,`cod_plato`,`orden`) VALUES 
 (1,1,1),
 (1,2,2),
 (1,3,3),
 (2,4,1),
 (2,5,2),
 (2,6,3),
 (3,1,1),
 (3,6,3),
 (3,7,2),
 (4,1,1),
 (4,2,2),
 (4,8,3),
 (5,9,1),
 (6,1,2),
 (6,2,3),
 (6,4,1);
/*!40000 ALTER TABLE `come` ENABLE KEYS */;


--
-- Definition of table `libreta`
--

DROP TABLE IF EXISTS `libreta`;
CREATE TABLE `libreta` (
  `amigo` varchar(20) NOT NULL,
  `primero` varchar(45) DEFAULT NULL,
  `precio_1` float DEFAULT NULL,
  `segundo` varchar(45) DEFAULT NULL,
  `precio_2` float DEFAULT NULL,
  `postre` varchar(45) DEFAULT NULL,
  `precio_3` float DEFAULT NULL,
  PRIMARY KEY (`amigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `libreta`
--

/*!40000 ALTER TABLE `libreta` DISABLE KEYS */;
INSERT INTO `libreta` (`amigo`,`primero`,`precio_1`,`segundo`,`precio_2`,`postre`,`precio_3`) VALUES 
 ('Antonia','paella',8.5,'pollo',4.7,'tarta',3.1),
 ('Felipa','espaguetti',5.3,'trucha',6.1,'flan',2.1),
 ('Juan','paella',8.5,'flamenquines',5.2,'flan',2.1),
 ('Luis','paella',8.5,'pollo',4.7,'fruta',1.5),
 ('Maria','cocido',13.2,NULL,NULL,NULL,NULL),
 ('Pedro','espaguetti',5.3,'paella',8.5,'pollo',4.7);
/*!40000 ALTER TABLE `libreta` ENABLE KEYS */;


--
-- Definition of table `plato`
--

DROP TABLE IF EXISTS `plato`;
CREATE TABLE `plato` (
  `cod_plato` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `plato` varchar(45) NOT NULL,
  `precio` float NOT NULL,
  PRIMARY KEY (`cod_plato`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `plato`
--

/*!40000 ALTER TABLE `plato` DISABLE KEYS */;
INSERT INTO `plato` (`cod_plato`,`plato`,`precio`) VALUES 
 (1,'paella',8.5),
 (2,'pollo',4.7),
 (3,'tarta',3.1),
 (4,'espaguetti',5.3),
 (5,'trucha',6.1),
 (6,'flan',2.1),
 (7,'flamenquines',5.2),
 (8,'fruta',1.5),
 (9,'cocido',13.2);
/*!40000 ALTER TABLE `plato` ENABLE KEYS */;


--
-- Definition of function `recauda`
--

DROP FUNCTION IF EXISTS `recauda`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ $$
CREATE DEFINER=`root`@`localhost` FUNCTION `recauda`(a varchar(45)) RETURNS float
BEGIN
        -- Declaracion de variables auxiliares
        DECLARE uno float;
        DECLARE dos float;
        DECLARE tres float;
        -- Compruebo cuanto se recauda en cualquiera de los platos
        SELECT precio_1 INTO uno FROM libreta WHERE amigo=a;
        SELECT precio_2 INTO dos FROM libreta WHERE amigo=a;
        SELECT precio_3 INTO tres FROM libreta WHERE amigo=a;
        -- Por si alguno es nulo
        IF uno IS NULL THEN SET uno=0; END IF;
        IF dos IS NULL THEN SET dos=0; END IF;
        IF tres IS NULL THEN SET tres=0; END IF;
        -- Devuelvo el resultado
        return (uno+dos+tres);
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `comprueba`
--

DROP PROCEDURE IF EXISTS `comprueba`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `comprueba`()
BEGIN
        -- La factura con la tabla libreta
        select amigo,recauda(amigo) from libreta;
        -- La consulta con las tablas amigo,plato y come
        SELECT amigo,sum(precio)
        FROM amigo,plato,come
        WHERE come.cod_amigo=amigo.cod_amigo
        AND come.cod_plato=plato.cod_plato
        GROUP BY amigo;
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `divide_1`
--

DROP PROCEDURE IF EXISTS `divide_1`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `divide_1`()
BEGIN
        -- Variables donde recoger los datos del CURSOR
        DECLARE nombre_amigo varchar(45);
        -- Variables que van a ser los codigos del amigo y del plato
        DECLARE numero_amigo int DEFAULT 1;
        -- El CURSOR con su marcador de final de recorrido
        DECLARE acabado BOOLEAN DEFAULT FALSE;
        DECLARE todo CURSOR FOR SELECT amigo FROM libreta;
        DECLARE CONTINUE HANDLER FOR SQLSTATE '02000' SET acabado = TRUE;
        -- Borramos los datos de las tablas, por si hay algo
        DELETE FROM amigo;
        -- Recorremos el CURSOR
        OPEN todo;
        FETCH todo INTO nombre_amigo;
        REPEAT
                -- Damos de alta al amigo
                INSERT INTO amigo (cod_amigo,amigo) VALUES (numero_amigo,nombre_amigo);
                -- Siguiente registro
                SET numero_amigo=numero_amigo+1;
                FETCH todo INTO nombre_amigo;
        UNTIL acabado END REPEAT;
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `divide_2`
--

DROP PROCEDURE IF EXISTS `divide_2`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `divide_2`()
BEGIN
       -- Variables donde recoger los datos del CURSOR
        DECLARE pl1 varchar(45);
        DECLARE pl2 varchar(45);
        DECLARE pl3 varchar(45);
        DECLARE pr1 float;
        DECLARE pr2 float;
        DECLARE pr3 float;
        -- El CURSOR con su marcador de final de recorrido
        DECLARE acabado BOOLEAN DEFAULT FALSE;
        DECLARE todo CURSOR FOR SELECT primero,precio_1,segundo,precio_2,postre,precio_3 FROM libreta;
        DECLARE CONTINUE HANDLER FOR SQLSTATE '02000' SET acabado = TRUE;
        -- Borramos los datos de las tablas, por si hay algo
        DELETE FROM plato;
        -- Recorremos el CURSOR
        OPEN todo;
        FETCH todo INTO pl1,pr1,pl2,pr2,pl3,pr3;
        REPEAT
                call inserta(pl1,pr1);
                call inserta(pl2,pr2);
                call inserta(pl3,pr3);
                FETCH todo INTO pl1,pr1,pl2,pr2,pl3,pr3;
        UNTIL acabado END REPEAT;



END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `divide_3`
--

DROP PROCEDURE IF EXISTS `divide_3`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `divide_3`()
BEGIN
        -- Variables donde recoger los datos del CURSOR
        DECLARE cli varchar(45);
        DECLARE pl1 varchar(45);
        DECLARE pl2 varchar(45);
        DECLARE pl3 varchar(45);
        -- Variables donde coger los codigos
        DECLARE cc int;
        DECLARE c1 int;
        DECLARE c2 int;
        DECLARE c3 int;
        -- El CURSOR con su marcador de final de recorrido
        DECLARE acabado BOOLEAN DEFAULT FALSE;
        DECLARE todo CURSOR FOR SELECT amigo,primero,segundo,postre FROM libreta;
        DECLARE CONTINUE HANDLER FOR SQLSTATE '02000' SET acabado = TRUE;
        -- Borramos los datos de las tablas, por si hay algo
        DELETE FROM come;
        -- Recorremos el CURSOR
        OPEN todo;
        FETCH todo INTO cli,pl1,pl2,pl3;
        REPEAT
                -- Buscamos el codigo del cliente
                SELECT cod_amigo INTO cc FROM amigo WHERE amigo=cli;
                -- Buscamos el codigo de los 3 platos y los insertamos
                if pl1 is not null then
                        SELECT cod_plato INTO c1 FROM plato WHERE plato=pl1;
                        INSERT INTO come (cod_amigo,cod_plato,orden) VALUES (cc,c1,1);
                end if;
                if pl2 is not null then
                        SELECT cod_plato INTO c2 FROM plato WHERE plato=pl2;
                        INSERT INTO come (cod_amigo,cod_plato,orden) VALUES (cc,c2,2);
                end if;
                if pl3 IS NOT NULL THEN
                        SELECT cod_plato INTO c3 FROM plato WHERE plato=pl3;
                        INSERT INTO come (cod_amigo,cod_plato,orden) VALUES (cc,c3,3);
                END IF;
                -- Vamos al siguiente registro
                FETCH todo INTO cli,pl1,pl2,pl3;
        UNTIL acabado END REPEAT;

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `inserta`
--

DROP PROCEDURE IF EXISTS `inserta`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `inserta`(pl varchar(45),pr float)
BEGIN
        DECLARE cp int;
        -- ¿Existe el plato?
        SELECT cod_plato INTO cp FROM plato WHERE plato=pl;
        -- Si no existe, lo inserto. Si existe no hago nada
        IF cp IS NULL THEN
                SELECT max(cod_plato) INTO cp FROM plato;
                IF cp IS NULL THEN
                        SET cp=1;
                ELSE
                        SET cp=cp+1;
                END IF;
                INSERT INTO plato (cod_plato,plato,precio) VALUES (cp,pl,pr);
        END IF;
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;



/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
